/* -*- mode: C++; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

#ifndef GFP_GPU_CUH_
#define GFP_GPU_CUH_

#include <string>
#include <sstream>
#include <iostream>
using namespace std;

#include "utils.hpp"
#include "integer.cuh"


template<uint N,typename Alloc=LocalMemory >
class GFp {
public:

#ifdef __UseTex
	const Integer<N,Alloc>  _prime;
#else
	Integer<N, Alloc> _prime;
#endif

	uint                     _invp;
	Integer<N,LocalMemory>   _var1;
	//	Integer<N,LocalMemory>   _var2;
	
	_HD_ GFp();
	
	_H_ GFp(string);

	template<typename Alloc1, typename Alloc2>
	_D_ void add_in(Integer<N,Alloc1>& , const Integer<N,Alloc2>&);

	template<typename Alloc1, typename Alloc2, typename Alloc3>
	_D_ void add(Integer<N,Alloc1>& , const Integer<N,Alloc2>&, const Integer<N,Alloc3>&) const;

	template<typename Alloc1, typename Alloc2>
	_D_ void sub_in(Integer<N,Alloc1>& , const Integer<N,Alloc2>&);

	template<typename Alloc1, typename Alloc2, typename Alloc3>
	_D_ void sub(Integer<N,Alloc1>& , const Integer<N,Alloc2>&, const Integer<N,Alloc3>&) const;

	template<typename Alloc1, typename Alloc2, typename Alloc3>
	_D_ void mul(Integer<N,Alloc1>& , const Integer<N,Alloc2>&, const Integer<N,Alloc3>&);

	template<typename Alloc1, typename Alloc2>
	_D_ void mul(Integer<N,Alloc1>& , int, const Integer<N,Alloc2>&);

	template<typename Alloc1, typename Alloc2>
	_D_  void convertFromMontg(Integer<N,Alloc1>& , const Integer<N,Alloc2>&);

	template<typename Alloc1, typename Alloc2>
	_D_  void convertToMontg(Integer<N,Alloc1>& , const Integer<N,Alloc2>&);
};

#include "gfp_gpu.cu"

#endif //GFP_GPU_CUH_
